#include <s11n.net/s11n/classload.hpp> 


#include <qt.h>
#include <qtextbrowser.h>
#include <qcanvas.h>

#include "classload.hpp"

namespace s11n { namespace qt {

        template <>
        struct widget_factory<QTextBrowser> // just a test
        {
                static QWidget * factory()
                {
                        //CERR << "QTextBrowser factory!\n";
                        QTextBrowser * b = new QTextBrowser( 0, 0 );
                        return b;
                }
        };


        template <>
        struct widget_factory<QCanvasView> // just a test
        {
                static QWidget * factory()
                {
                        //CERR << "QCanvasView factory!\n";
                        QCanvasView * b = new QCanvasView;
                        return b;
                }
        };



        QWidget * create_widget( const std::string & classname )
        {
                return ::s11n::cl::classload<QWidget>( classname );
        }


} } // s11n::qt

namespace {

        void init_classloader()
        {
#define REG(T) s11n::qt::register_widget< T >( # T );
//                 CERR << "registering widget type " << # T << "\n";

                REG(QPushButton);
                REG(QLabel);
                REG(QTextBrowser);
                REG(QCanvasView);
#undef REG
        }
        int bogus_init = (init_classloader(),0);
} // anon namespace

